from glmaps import *
import time


def main():
    local_ip = "192.168.12.189"
    local_port = 10024
    card_number = "1"
    timeslot = "1"
    enable_traffic = 1
    # protocol = "ISUP"

    local_server = IsupClient(local_ip, local_port, "Sig-Card1_B-Port_1.xml")
    print "Isup Server Connection...",
    if local_server.connect() == 0:
        time.sleep(1)
        print True
        print "Isup Testbed Starting...",
        if local_server.start_testbed() == 0:
            print True
            print "Isup Profile Loading...",
            if local_server.load_profile_group() == 0:
                print True
                time.sleep(10)
                print "MTP3 Health Status Checking...",
                if local_server.server_health_status_request(enable_traffic) == 0:
                    print True
                    local_server.set_global_variable("_EnableCLI", "(i)", str(1))
                    if local_server.status == "STARTED":
                        profile = "Card" + str(card_number) + "TS01"
                        my_call = local_server.start_call_script("HIGH", "PLACE_CALL", profile)
                        if my_call.handle != 0:
                            print "MTP3 Link is UP...",
                            if my_call.is_transport_up() == 0:
                                print True

                                print "Set CardNumber: %s" % my_call.set_local_variable("CardNumber", "(s)",
                                                                                        card_number)
                                print "Set Timeslot: %s" % my_call.set_local_variable("Timeslot", "(s)", timeslot)

                                print "Isup Call Placing On CARD%sTS%s..." % (card_number, timeslot),
                                if my_call.place_call() == 0:
                                    print True
                                    print "Isup Call Connecting...",
                                    if my_call.wait_for_call_connect("PLACE_CALL", 4000) == 0:
                                        print True

                                    for count in range(0, 10):
                                        print "Isup Call Status...%s" % my_call.get_call_status()
                                        time.sleep(1)
                                        if my_call.status == "ISUP CALL CONNECTED":
                                            break

                                    print "Isup Hold Call...",
                                    if my_call.hold_call() == 0:
                                        print True
                                        time.sleep(2)
                                        print "Isup Retrieve Call...",
                                        if my_call.retrieve_call() == 0:
                                            print True
                                            time.sleep(2)
                                        else:
                                            print False
                                    else:
                                        print False

                                    print "Isup Suspend Call...",
                                    if my_call.suspend_call() == 0:
                                        print True
                                        time.sleep(2)
                                        print "Isup Resume Call...",
                                        if my_call.resume_call() == 0:
                                            print True
                                            time.sleep(2)
                                        else:
                                            print False
                                    else:
                                        print False

                                    """ Traffic Actions """

                                    # print "RxFile: %s" % my_call.tdm_action.receive_file()
                                    # print "RxFile Completion: %s" % my_call.tdm_action.wait_for_rx_file_completion(
                                    #     11000)
                                    # print "TxFile: %s" % my_call.tdm_action.send_file()
                                    # print "TxFile Completion: %s" % my_call.tdm_action.wait_for_tx_file_completion(
                                    #     22000)
                                    # time.sleep(2)
                                    #
                                    # print "RxDigits: %s" % my_call.tdm_action.detect_digits()
                                    # print "RxDigits Completion: %s" % my_call.tdm_action.wait_for_digit_detection(5000)
                                    # print "GetDigits: %s" % my_call.tdm_action.get_detected_digits()
                                    # time.sleep(2)
                                    # print "TxDigits: %s" % my_call.tdm_action.send_digits()
                                    # time.sleep(4)
                                    #
                                    # print "RxTone: %s" % my_call.tdm_action.detect_tones(15000)
                                    # print "RxTone Completion: %s" % my_call.tdm_action.wait_for_tone_detection(12000)
                                    # print "*** Getting RxTone Frequency and Power ***\n%s" % my_call.tdm_action.get_detected_tones()
                                    # print "TxTone: %s" % my_call.tdm_action.send_tones()
                                    # print "TxTone Completion: %s" % my_call.tdm_action.wait_for_tx_tone_completion(
                                    #     12000)
                                    # time.sleep(2)
                                    #
                                    # print "TxFax: %s" % my_call.tdm_action.send_fax()
                                    # print "TxFax Completion: %s" % my_call.tdm_action.wait_for_tx_fax_completion(50000)
                                    # time.sleep(5)
                                    #
                                    # print "SilenceDetection: %s" % my_call.tdm_action.silence_detection(2000)
                                    # time.sleep(5)

                                    time.sleep(2)
                                    print "Isup Call Terminating...",
                                    if my_call.terminate_call() == 0:
                                        print True

                                    # print "Isup Call Clearing...",
                                    # if my_call.clear_call() == 0:
                                    #     print True
                                    #
                                    # print "Isup Call/Circuit Reset...",
                                    # if my_call.initiate_reset() == 0:
                                    #     print True

                                    time.sleep(1)
                                    print "Isup MsgCount: %s" % my_call.get_message_count()
                                    print "Isup LastMSGRcv: %s" % my_call.get_last_received_message()
                                    print "***** Isup Call Flow *****"
                                    print "Time Stamp\tRoute\tMessage"
                                    for index in range(0, my_call.get_message_count()):
                                        my_call.message_list.append(my_call.get_message(index))
                                        print my_call.message_list[index]

                                    print "Isup Script Stopping...",
                                    if local_server.stop_call_script(my_call) == 0:
                                        print True
                                else:
                                    print False
                else:
                    print False
            else:
                print False
        else:
            print False
            print "MTP3 Health Status Checking...",
            print local_server.server_health_status_request(enable_traffic)
    else:
        print False
        print "MTP3 Health Status Checking...",
        print local_server.server_health_status_request(enable_traffic)
        print "Isup Server Disconnecting...",
        if local_server.disconnect() == 0:
            print True


if __name__ == "__main__":
    main()
